package de.polygonal.ds {
	import de.polygonal.ds.DLLNode;
	import de.polygonal.ds.Itr;
	import de.polygonal.ds.DLL;
	import flash.Boot;
	public class CircularDLLIterator implements de.polygonal.ds.Itr{
		public function CircularDLLIterator(f : de.polygonal.ds.DLL = null) : void { if( !flash.Boot.skip_constructor ) {
			this._f = f;
			this.reset();
		}}
		
		protected var _f : de.polygonal.ds.DLL;
		protected var _walker : de.polygonal.ds.DLLNode;
		protected var _i : int;
		protected var _s : int;
		protected var _hook : de.polygonal.ds.DLLNode;
		public function reset() : de.polygonal.ds.Itr {
			this._walker = this._f.head;
			this._s = this._f.size();
			this._i = 0;
			this._hook = null;
			return this;
		}
		
		public function hasNext() : Boolean {
			return this._i < this._s;
		}
		
		public function next() : * {
			var x : * = this._walker.val;
			this._hook = this._walker;
			this._walker = this._walker.next;
			this._i++;
			return x;
		}
		
		public function remove() : void {
			this._f.unlink(this._hook);
			this._i--;
			this._s--;
		}
		
	}
}
