package de.polygonal._Printf {
	import de.polygonal._Printf.FloatType;
	import de.polygonal._Printf.IntegerType;
	public final class FormatDataType extends enum {
		public static const __isenum : Boolean = true;
		public function FormatDataType( t : String, index : int, p : Array = null ) : void { this.tag = t; this.index = index; this.params = p; }
		public static function FmtFloat(floatType : de.polygonal._Printf.FloatType) : FormatDataType { return new FormatDataType("FmtFloat",1,[floatType]); }
		public static function FmtInteger(integerType : de.polygonal._Printf.IntegerType) : FormatDataType { return new FormatDataType("FmtInteger",0,[integerType]); }
		public static var FmtNothing : FormatDataType = new FormatDataType("FmtNothing",4);
		public static var FmtPointer : FormatDataType = new FormatDataType("FmtPointer",3);
		public static var FmtString : FormatDataType = new FormatDataType("FmtString",2);
		public static var __constructs__ : Array = ["FmtInteger","FmtFloat","FmtString","FmtPointer","FmtNothing"];
	}
}
