package de.polygonal._Printf {
	import de.polygonal._Printf.FormatDataType;
	public final class FormatToken extends enum {
		public static const __isenum : Boolean = true;
		public function FormatToken( t : String, index : int, p : Array = null ) : void { this.tag = t; this.index = index; this.params = p; }
		public static function BareString(str : String) : FormatToken { return new FormatToken("BareString",0,[str]); }
		public static function Property(name : String) : FormatToken { return new FormatToken("Property",2,[name]); }
		public static function Tag(type : de.polygonal._Printf.FormatDataType, args : *) : FormatToken { return new FormatToken("Tag",1,[type,args]); }
		public static function Unknown(str : String, pos : int) : FormatToken { return new FormatToken("Unknown",3,[str,pos]); }
		public static var __constructs__ : Array = ["BareString","Tag","Property","Unknown"];
	}
}
